# Controller API

## Voraussetzungen

* Prüfe ob Python Version 3.x installiert ist
> python --version

## Setup private Python Repository (pip Repro)

* Lasse Deinen Nutzer beim Nexus freischalten (https://update.fischertechnik-cloud.com)
* Installiere alle abhängigen Bibliotheken
> cd txtapi
> pip install -r requirements.txt --extra-index-url https://update.fischertechnik-cloud.com/repository/ft-txt-lib/simple/
* Benutzername und Password müssen dann auf der Kommandozeile eingegeben werden

## Git Hook erstellen

Konfiguriere einen Git-Hook, sodass die Versionsnummern automatisch inkrementiert werden.

> git config --local core.hooksPath .githooks/

## Release durchführen

* Prüfen ob der letzte Stand ohne Änderungen lokal vorhanden ist 

> git pull
 
> git status
   
* Abhängigkeit zur Controllerlib aktualisieren
(Datei: txtapi/setup.py)
> ft-controllerlib==2.0.0

* Letzten Tag ermittlen
> git tag

* Neuen Tag erstellen und im Repository veröffentlichen
> git tag release/2.0.0 -m "Message with last changes"

* Tags der folgenden Form lösen ein Release aus:

> release/2.0.0a0 = alpha

> release/2.0.0b0 = beta

> release/2.0.0rc0 = release candidate

> release/2.0.0 = release

* Bei einem alpha, beta und rc wird nur zum Nexus deployed

* Bei einem finalen Release wird auch der stable-Branch aktualisiert.

* Der Tag kann auch direkt in Gerrit gesetzt werden:
  https://review.beemo.eu/admin/repos/ft/python/roboticsstudio/controllerapi,tags
